#pragma once

#include "text.hpp"
#include "ds_vk_base.hpp"

namespace gz::vlk {

	class TextVkDS : public DrawStrategy<Text>, public VulkanDS, public VulkanTexturedDS {
        public:
			TextVkDS(Renderer2D& renderer, BufferManager<Vertex2D, uint32_t>& bufferManager, const std::string& textureName);
            /**
             * @todo
             */
            void draw() override;

            /**
             * @brief Set the new vertices and indices
             */
            void update(const Text& text) override;
        private:
            void setTextureCoordinates();
    };

}  // namespace gz::vlk
